;; (c) 17/08/2007 TIG - This is free-to-use-but-please-acknowledge-the-author-ware
;; Takes selected Text/Mtext - e.g. spot heights - and reads value and moves in Z to suit 
;; - if it is originally in m > mm in Z.  Edit the z (* 1000... to (* 1... if you are in metres.
;; Best to pre-select the Text items you want 1st using a filter in AutoCAD before running it...
;; Adds 3D point at same location as Text origin.  
;; You can use 3D points in other programs for 3D work, meshes etc.
;; Appload file by name and to run type 'text2d3d'.
;; Note that origin of the Text = '3D-point' rather that any + 'marker'.  
;; However, IF you know that the Text is constantly offset in XY from the + marker then...
;; you could move all of the new points back by that amount in the XY,
;; so as to put them over the 2D + marker...
;; With the import it's best to have only the new 3D-points in the DWG - 
;; so save a copy and then filter+erase the text/markers to leave just 3D-points...
;;
(defun C:text2d3d ( / ctr num tent tlst x y z)
  (command "_undo" "begin")
  (setvar "PDMODE" 35)(setvar "PDSIZE" 0)
  (princ"\n.\n.\n.\n")
  (prompt "Select the 'Spot-Height' Text-Entities to move to their true Z: ")
  (ssget)
  (setq ctr 0 num (sslength(ssget "P" '((0 . "*TEXT")))))
  (repeat num
    (setq tent (ssname(ssget "P" '((0 . "*TEXT")))ctr) tlst (entget tent))
    (setq x    (car (cdr(assoc 10 tlst)))
          y    (cadr(cdr(assoc 10 tlst)))
          z    (* 1000 (atof(cdr(assoc  1 tlst))))
          tlst (subst(cons 10 (list x y z))(assoc 10 tlst)tlst)
    );;end setq
    (entmod tlst)
    (command "_point" (strcat (rtos x)","(rtos y)","(rtos z)))
    (setq ctr (1+ ctr))
  );;end repeat
  (command "_undo" "end")
  (princ (strcat"\n.\n.\n.\n"(itoa num)" Text-Entities Moved to their true Z, with Points added."))
  (princ)
);;end def